/**
 * f2nd.java - jpq - 16/05/99
 * jdk1.2 - double-buffering
 * modification et ajout de geo et de main() le 11/01/18 ; modification le 24/09/22
 */

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import geo.*;

public class f2nd extends Panel implements MouseListener, MouseMotionListener, ActionListener {
	static final long serialVersionUID = 220924L;
	static Image img;
	static Graphics g;
	static Repere R;
	static PointLibre O, I;
	TextField tf, tux, tuy;
	Button ok, nvf;
	static StringTokenizer st;
	double liste [];
	int nliste;
	int max;
	int Yf [], Yf1 [];
	boolean erreur, der, dernbr, resval;
	double a, b, c;
	int t;
	int X, Y;
	double pile [];
	int npile;
	Random rnd;
	double ux, uy;
	int gw, gh;

	private double hasard() {
		return (double)(rnd.nextInt (9) - 2) / 2.0;
	}

	private void nf() {
		t = Math.abs (rnd.nextInt()) % 5;
		do {
			a = hasard();
		} while (a == 0.0);
		b = hasard();
		c = hasard();
	}

	private void f1() {
		for (int X = 0; X < R.XMAX; X++) {
			double x = R.x (X);
			double d = 0;
			boolean val = true;
			switch (t) {
				case 0 :
					d = a * x + b;
					break;
				case 1 :
					if (val = (x != - b))
						d = a / (x + b) + c;
					break;
				case 2 :
					if (val = (x >= - b))
						d = a * Math.sqrt (x + b) + c;
					break;
				case 3 :
					d = x + b;
					d = a * d * d + c;
					break;
				case 4 :
					d = x + b;
					d = a * d * d * d + c;
			}
			if (val)
				Yf1 [X] = R.Y (d);
			else
				Yf1 [X] = -1;
		}
	}

//------------------------------------------------------------------------------
	private void analyse() {
		erreur = false;
		st = new StringTokenizer (tf.getText (), " ()*+-/^,", true);
		nliste = 0;
		parse();
	}

	private void parse() {
		der = true;
		int i = 0;
		while (st.hasMoreTokens()) {
			if (p (i) == -1)
				break;
			i++;
		}
	}

	private String suivant() {
		String s = "";
		while (st.hasMoreTokens() && (s.length() == 0))
			s = st.nextToken().trim();
		return s;
	}

	private int p (int i) {
		int resultat = -1;
		String s = suivant();
		if (s.equals (","))
			s = suivant();
		if (s.length() != 0) {
			try {
				addListe (Double.valueOf(s).doubleValue(), true);
				resultat = 0;
				der = false;
			}
			catch (NumberFormatException excp) {
				s = s.toUpperCase ();
				if (s.equals ("X")) {
					addListe (1.0, false);
					resultat = 0;
					der = false;
				} else if (s.equals ("PI")) {
					addListe (-1.0, false);
					resultat = 0;
					der = false;
				} else if (s.equals ("E")) {
					addListe (-2.0, false);
					resultat = 0;
					der = false;
				} else if (s.equals ("(")) {
					parse();
					resultat = 0;
				} else if (s.equals (")")) {
					der = false;
				} else {
					int op = nop (s);
					if ((op == -22) && (i == 0))
						addListe (0.0, true);
					int opt = Math.abs (op);
					int opa = (i > 0) ? (int) liste [nliste - 1] : 0;
					int opat = Math.abs (opa);
					if ((opat < 20) || !der)
						opat = 0;
					int opb = 0;
					int opbt = 0;
					if ((opt >= 20) && (opt < opat)) {
						nliste--;
						if (nliste >= 1)
							opb = (int) liste [nliste - 1];
						opbt = Math.abs (opb);
						if (opbt < 20)
							opbt = 0;
						if ((opt < opbt) && (opbt < opat))
							nliste--;			 
					}
					boolean b = der;
					resultat = p (i);
					addListe ((double) op, false);
					der = b;
					if (opt >= 20) {
						if ((opt < opbt) && (opbt < opat))
							addListe ((double) opb, false);						
						if (opt < opat)
							addListe ((double) opa, false);
					}
					der = true;
				}
			}
		}
		return resultat;
	}

	private int nop (String s) {
		int r = 0;
		if (s.equals ("ABS")) r = 2;
		else if (s.equals ("SQRT"))
			r = 3;
		else if (s.equals ("LN"))
			r = 4;
		else if (s.equals ("EXP"))
			r = 5;
		else if (s.equals ("SIN"))
			r = 6;
		else if (s.equals ("COS"))
			r = 7;
		else if (s.equals ("TAN"))
			r = 8;
		else if (s.equals ("ASIN"))
			r = 9;
		else if (s.equals ("ACOS"))
			r = 10;
		else if (s.equals ("ATAN"))
			r = 11;
		else if (s.equals ("INT"))
			r = 12;
		else if (s.equals ("RND"))
			r = 13;
		else if (s.equals ("MAX"))
			r = 14;
		else if (s.equals ("MIN"))
			r = 15;
		else if (s.equals ("^"))
			r = 20;
		else if (s.equals ("*"))
			r = 21;
		else if (s.equals ("/"))
			r = -21;
		else if (s.equals ("+"))
			r = 22;
		else if (s.equals ("-"))
			r = -22;
		if (r == 0)
			erreur = true;
		return r;
	}

	private void addListe (double x, boolean b) { /* b = true : x == nombre */
		if (nliste >= max - 1)
			if (liste == null) {
				max = 20;
				liste = new double [max];
				pile = new double [max];
			} else {
				max *= 2;
				double[] nf = new double [max];
				System.arraycopy (liste, 0, nf, 0, liste.length);
				liste = nf;
				pile = new double [max];
			}
		if (b)
			liste [nliste++] = 0.0;
		liste [nliste++] = x;
	}

//------------------------------------------------------------------------------
	private void ccourbe() {
		for (int Xf = 0; Xf < R.XMAX; Xf++) {
			if (!erreur) {
				double d = image (R.x (Xf));
				if (resval)
					Yf [Xf] = R.Y (d);
				else
					Yf [Xf] = -1;
			} else
				Yf [Xf] = -1;
		}
	}

	private double image (double x) {
		resval = true;
		if ((liste == null) || (nliste == 0)) {
			resval = false;
			return Double.NaN;
		} else {
			npile = 0;
			int i = 0;
			while ((i < nliste) && (!erreur) && (resval)) {
				int id = (int) liste [i++];
				if (id == 0)
					pile [npile++] = liste [i++];
				else if (id == 1)
					pile [npile++] = x;
				else if (id == -1)
					pile [npile++] = Math.PI;
				else if (id == -2)
					pile [npile++] = Math.E;
				else if ((id >= 2) && (id < 14)) {
					if (npile == 0)
						erreur = true;
					else {
						double d = pile [-- npile];
						switch (id) {
							case 2 :
								d = Math.abs (d);
								break;
							case 3 :
								resval = (d >= 0.0);
								d = Math.sqrt (d);
								break;
							case 4 :
								resval = (d >= 0.0);
								d = Math.log (d);
								break;
							case 5 :
								d = Math.exp (d);
								break;
							case 6 :
								d = Math.sin (d);
								break;
							case 7 :
								d = Math.cos (d);
								break;
							case 8 :
								d = Math.tan (d);
								break;
							case 9 :
								resval = (d >= -1.0) && (d <= 1.0);
								d = Math.asin (d);
								break;
							case 10 :
								resval = (d >= -1.0) && (d <= 1.0);
								d = Math.acos (d);
								break;
							case 11 :
								d = Math.atan (d);
								break;
							case 12 :
								d = Math.floor (d);
								break;
							case 13 :
								d = rnd.nextDouble() * d;
						}
						pile [npile ++] = d;
					}
				} else {
					if (npile < 2)
						erreur = true;
					else {
						double d1 = pile [npile - 2];
						double d2 = pile [--npile];
						switch (id) {
							case 14 :
								d1 = Math.max (d1, d2);
								break;
							case 15 :
								d1 = Math.min (d1, d2);
								break;
							case 20 :
								try {
									d1 = Math.pow (d1, d2);
								}
								catch (ArithmeticException ae) {
									resval = false;
								}
								break;
							case 21 :
								d1 *= d2;
								break;
							case -21 :
								resval = (d2 != 0.0);
								d1 /= d2;
								break;
							case 22 :
								d1 += d2;
								break;
							case -22 :
								d1 -= d2;
						}
						pile [npile - 1] = d1;
					}
				}
			}
			if (!resval)
				return Double.NaN;
			else if (npile != 1) {
				erreur = true;
				return Double.NaN;
			} else
				return pile [0];
		}
	}

//------------------------------------------------------------------------------
	public f2nd() {
		ux = 50.0;
		uy = 50.0;
		t = 3;
		a = 1.0;
		b = 1.0;
		c = 1.0;

		add (tf = new TextField (30));
		add (new Label ("ux"));
		add (tux = new TextField (Double.toString (ux), 5));
		add (new Label ("uy"));
		add (tuy = new TextField (Double.toString (uy), 5));
		add (ok = new Button ("Ok"));
		ok.addActionListener (this);
		add (nvf = new Button ("Nouvelle fonction"));
		nvf.addActionListener (this);
		rnd = new Random ();
		addMouseMotionListener (this);
		addMouseListener (this);
		setBackground (Color.white);
	}

	private double arrondi (double d, double precision) {
		return Math.floor (d * precision) / precision;
	}

	public void update (Graphics g1) {
		paint (g1);
	}

	public void paint (Graphics g1) {
		if (img == null || gw != getSize().width || gh != getSize().height) {
			gw = getSize().width;
			gh = getSize().height;
			img = createImage (gw, gh);
			g = img.getGraphics ();
			g.setFont (new Font ("Arial", Font.PLAIN, 10));

			if (R == null) {
				R = new Repere (gw / 2, gh / 2, gw, gh, ux, uy);
				O = new PointLibre (0.0, 0.0);
				I = new PointLibre (1.0, 1.0);
			} else {
				R.MAJ (gw / 2, gh / 2, gw, gh, ux, uy);
				O.MAJ (0.0, 0.0);
				I.MAJ (1.0, 1.0);
			}
			Yf = new int [R.XMAX];
			Yf1 = new int [R.XMAX];
			for (int X = 0; X < R.XMAX; X ++)
				Yf [X] = -1;
		}

		g.setColor (getBackground ());
		g.fillRect (0, 0, R.XMAX, R.YMAX);

		R.MAJ (R.X (O.x), R.Y (O.y), gw, gh, R.unitex, R.unitey);
		O.MAJ (0.0, 0.0);
		if (I.deplace) {
			double Ix = I.x;
			double Iy = I.y;
			if (Ix > 0.0 && Iy > 0.0) {
				ux = (double) (R.X (Ix) - R.X0);
				uy = (double) (R.Y0 - R.Y (Iy));
				R.MAJ (R.X0, R.Y0, gw, gh, ux, uy);
				tux.setText (Double.toString (ux));
				tuy.setText (Double.toString (uy));
			}
		}
		I.MAJ (1.0, 1.0);

		ccourbe ();
		f1();

		g.setColor (Color.BLACK);
		g.drawString ("(" + arrondi (R.x (X), 100.0) + ", " + arrondi (R.y (Y), 100.0) + ")", 2, 40);

		g.setColor (Color.RED);
		R.trace (g);
		O.trace ("O", R, g);
		I.trace ("I", R, g);

		g.setColor (Color.GREEN);
		for (int X = 0; X < R.XMAX; X ++) {
			int Y = Yf1 [X];
			g.drawLine (X, Y, X, Y);
		}

		g.setColor (Color.RED);
		boolean pasexact = false;
		for (int X = 0; X < R.XMAX; X ++)
			if ((Yf1 [X] >= 0) && (Yf1 [X] < R.XMAX))
				if (pasexact = (Yf [X] != Yf1 [X]))
					break;
		if (!pasexact)
			g.drawString ("Exact", 2, getSize().height - 10);

		if (erreur)
			g.drawString ("Erreur de syntaxe", 2, getSize().height - 10);
		else {
			g.setColor (Color.BLUE);
			for (int X = 0; X < R.XMAX; X ++) {
				int Y = Yf [X];
				g.drawLine (X, Y, X, Y);
			}
		}

//		g.setColor (Color.BLACK);
//		R.cadre (g);

		g1.drawImage (img, 0, 0, this);
	}

	public void mousePressed (MouseEvent e) {
		X = e.getX();
		Y = e.getY();
		if (I.deplace = I.zone (X, Y, R)) {
		} else if (O.deplace = O.zone (X, Y, R)) {
		}
	}

	public void mouseDragged (MouseEvent e) {
		X = e.getX();
		Y = e.getY();
		I.bouge (X, Y, R);
		O.bouge (X, Y, R);
		repaint();
	}

	public void mouseReleased (MouseEvent e) {
		O.deplace = I.deplace = false;
	}

	public void mouseMoved (MouseEvent e) {
		X = e.getX();
		Y = e.getY();
		if (I != null && I.zone (X, Y, R) || O != null && O.zone (X, Y, R)) {
			setCursor (new Cursor (Cursor.HAND_CURSOR));
		} else {
			setCursor (new Cursor (Cursor.DEFAULT_CURSOR));
		}
		repaint();
	}

	public void mouseClicked (MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {}
	public void mouseExited (MouseEvent e) {}

	public void actionPerformed (ActionEvent e) {
		if (e.getSource() == ok) {
			double nux = 0.0, nuy = 0.0;
			try {
				nux = Double.parseDouble (tux.getText());
			} catch (NumberFormatException nfe) {}
			try {
				nuy = Double.parseDouble (tuy.getText());
			} catch (NumberFormatException nfe) {}
			if (nux > 0.0)
				ux = nux;
			if (nuy > 0.0)
				uy = nuy;
			tux.setText (Double.toString (ux));
			tuy.setText (Double.toString (uy));
			R.MAJ (R.X0, R.Y0, getSize().width, getSize().height, ux, uy);
//			I.MAJ (1.0, 1.0);
			analyse();
			repaint();
		} else if (e.getSource() == nvf) {
			nf();
			repaint();
		}
	}

	public static void main (String [] args) {
		int w = 600;
		int h = 450;
		f2nd f2 = new f2nd();
		JFrame f = new JFrame ("f2nd");
		f.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		f.add (f2);
		f.setSize (w, h);
		f.setVisible (true);
	}

}